let Service = Services(PBConstants.BASE_API_URL, PBConstants.MARKET_CAP_API_URL, PBConstants.CURRENCIES_API_URL, PBConstants.LOGS_API_URL);
var currentlyEditing = 'default';
let NormalizerService = Service.Normalizer;
let configFiles = ['PAIRS', 'DCA', 'INDICATORS'];
let silent = false;

var showError = true;
let supportAccess = false;

function checkRole() {
    var data = RouteHelper.getServerData();
    var role;
    if (data){
        role = data.settings ? data.settings.role : '';
    }
    if (role !== undefined && role.toUpperCase() === PBConstants.ENABLE_SETTINGS_BTNS_ROLE) {
        showError = false;
    }
    if(role === 'S') {
        supportAccess = true;
    }
}
/*
 ************* MODALS ***************
 * SweetAlert modal functions called by eventListeners
 */
let Modals = (function() {

    function hotConfigModal(command) {
        let activeConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];

        Swal.fire({
            title: i18next.t('hotConfig.swalTitle'),
            text: i18next.t('hotConfig.swalText') + command,
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if (result.value && !supportAccess) {

                Service.saveConfigFile("HOTCONFIG", command, activeConfig, showError);
                Swal.fire(i18next.t('alertMsgs.sent') + " " + command + i18next.t('alertMsgs.to') + activeConfig + '.');
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function switchConfigModal(e) {
        let configName = e.target.value;
        Swal.fire({
            text: i18next.t('alertMsgs.switchConfigText') + configName + '!',
            type: 'warning',
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.confirmText') + configName + '!',
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if (result.value && !supportAccess) {
                switchActiveConfig(configName);
                Swal.fire(i18next.t('alertMsgs.switchedText'));
                $(document).trigger('evt.load-page-data');
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            } else {
                let switchBack = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];
                d.gEBI("switchActiveConfig").value = switchBack;
            }
        });
    }

    function hotModal() {
        let activeConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];

        Swal.fire({
            text: i18next.t('alertMsgs.hotConfig') + activeConfig,
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
            input: 'text',
            inputPlaceholder: i18next.t('alertMsgs.inputPlaceholder'),
            inputValidator: (value) => {
                if (!value) {
                    return '<b>' + i18next.t('alertMsgs.insertValue') + '</b>';
                }
            }
        }).then(result => {
            checkRole();
            if(result.value && !supportAccess) {
                Service.saveConfigFile("HOTCONFIG", result.value, activeConfig, showError);
                Swal.fire(i18next.t('alertMsgs.sent') + " " + result.value + i18next.t('alertMsgs.to') + activeConfig + '.');
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function resetBotModal() {
        Swal.fire({
            title: i18next.t('alertMsgs.resetQues'),
            text: i18next.t('alertMsgs.resetTestModeData'),
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.reset'),
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if(result.value && !supportAccess) {
                Service.resetProfitTrailer();
                Swal.fire(i18next.t('alertMsgs.resettingPT')).then(result => {
                    page('setup/exchange');
                })
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function panicSellModal(e) {
        Swal.fire({
            title: i18next.t('alertMsgs.panicSell'),
            text: i18next.t('alertMsgs.turningOnPanicSellWarning'),
            type: "warning",
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.ok'),
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if(!supportAccess) {
                changeSettingHandler(e)
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function removeConfigModal() {
        Swal.fire({
            title: i18next.t('alertMsgs.sureText'),
            text: i18next.t('alertMsgs.recoverFile'),
            type: "warning",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.submitBtn'),
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if(result.value && !supportAccess) {
                removeConfigFileHandler();
                Swal.fire(i18next.t('alertMsgs.deleted'));
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function newConfigNameModal() {
        let editingConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['editingConfig'];
        let maxConfigsAllowed = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['maxConfigsAllowed'];
        if (LS.gO(NormalizerService.generateLocalStorageKey('settings'))['availableConfigs'].length < maxConfigsAllowed) {
            Swal.fire({
                title: i18next.t('alertMsgs.newConfigName'),
                text: i18next.t('alertMsgs.copiedToNewConfig', {
                    editingConfig: editingConfig
                }),
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
                confirmButtonColor: '#DD6B55',
                confirmButtonText: i18next.t('alertMsgs.save'),
                reverseButtons: true,
                input: 'text',
                inputPlaceholder: i18next.t('alertMsgs.newConfigurationName'),
                inputValidator: (value) => {
                    if (!value) {
                        return '<b>' + i18next.t('alertMsgs.insertValue') + '</b>';
                    }
                }
            }).then(result => {
                checkRole();
                if(result.value && !supportAccess) {
                    newConfigNameInputSave(result.value);
                } else if(supportAccess) {
                    Swal.fire(i18next.t('alertMsgs.notAllowed'));
                }
            })
        } else {
            Swal.fire(i18next.t('alertMsgs.maxConfigurations', {
                maxConfigsAllowed: maxConfigsAllowed
            }));
        }
    }

    function releaseAmount(e) {
        Swal.fire({
            title: i18next.t('releaseAmount.title', {
                pair: e.target.dataset.pair
            }),
            text: i18next.t('releaseAmount.title'),
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('releaseAmount.confirm'),
            reverseButtons: true,
            input: 'text',
            inputPlaceholder: "1000",
            inputValue: e.target.dataset.amount,
            inputValidator: (value) => {
                if (!value) {
                    return '<b>'+ i18next.t('alertMsgs.insertValue') +'</b>';
                }
            }
        }).then(result => {
            checkRole();
            if(result.value && !supportAccess) {
                Service.releaseAmount(e.target.dataset.pair, result.value, showError);
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }
    function cancelReversal(e) {
        Swal.fire({
            title: i18next.t('reversal.title', {
                pair: e.target.dataset.pair
            }),
            text: i18next.t('reversal.text'),
            showCancelButton: true,
            cancelButtonText: i18next.t('reversal.close'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('reversal.confirm'),
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if(result.value && !supportAccess) {
                Service.cancelReversal(e.target.dataset.position, showError);
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function reserveAmount(e) {
        Swal.fire({
            title: i18next.t('reserveAmount.title', {
                pair: e.target.dataset.pair
            }),
            text: i18next.t('reserveAmount.title'),
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('reserveAmount.confirm'),
            reverseButtons: true,
            input: 'text',
            inputPlaceholder: "1000",
            inputValue: e.target.dataset.amount,
            inputValidator: (value) => {
                if (!value) {
                    return '<b>'+ i18next.t('alertMsgs.insertValue') +'</b>';
                }
            }
        }).then(result => {
            checkRole();
            if(result.value && !supportAccess) {
                Service.reserveAmount(e.target.dataset.pair, result.value, showError);
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function addBuyOrSalesRecord(e) {
        let buyOrSell = e.target.dataset.type;
        let placeholderPair = document.getElementsByClassName('market') ? document.getElementsByClassName('market')[1].innerText : '';
        let isLeverageExchange = typeof RouteHelper.getServerData().settings === 'undefined' ? true : RouteHelper.getServerData().settings.isLeverageExchange;
        let html = '';

        if(buyOrSell === 'buy') {
            html =
                '<div class="form-group text-left">' +
                '<label for="buyLogCurrencyPair">'+i18next.t('buyLogSection.coin.colName')+'</label>' +
                '<input type="text" class="form-control" id="buyLogCurrencyPair" name="buyLogCurrencyPair" placeholder="'+ placeholderPair +'" required>' +
                '<small class="form-text text-muted" data-i18n="">Coin needs to follow the same format, as the other coins you see in the different log areas, such as the Possible Buy Log, Pairs log, etc.</small>' +
                '</div>' +
                '<div class="form-group text-left">' +
                '<label for="buyLogAmount">'+i18next.t('buyLogSection.boughtAmount.colName')+'</label>' +
                '<input type="number" class="form-control" id="buyLogAmount" name="buyLogAmount" placeholder="1000" required>' +
                '</div>' +
                '<div class="form-group text-left">' +
                '<label for="buyLogAvgPrice">'+i18next.t('buyLogSection.boughtPrice.colName')+'</label>' +
                '<input type="number" class="form-control" id="buyLogAvgPrice" name="buyLogAvgPrice" placeholder="0.00000400" required>' +
                '</div>';
            if(isLeverageExchange) {
                html +=
                    '<div class="form-group text-left">' +
                    '<label for="buyLogLeverage">'+i18next.t('addRecordModal.leverage')+'</label>' +
                    '<input type="number" id="buyLogLeverage" name="buyLogLeverage" placeholder="100" class="form-control">' +
                    '</div>';
            }
        } else {
            html =
                '<div class="form-group text-left">' +
                '<label for="salesLogCurrencyPair">'+i18next.t('salesLogSection.coin.colName')+'</label>' +
                '<input type="text" id="salesLogCurrencyPair" name="salesLogCurrencyPair" class="form-control" placeholder="'+ placeholderPair +'">' +
                '<small>Coin needs to follow the same format, as the other coins you see in the different logs, such as Possible Buy Log, Pairs Log, etc.</small>' +
                '</div>' +
                '<div class="form-group text-left">' +
                '<label for="salesLogAmount">'+i18next.t('salesLogSection.soldAmount.colTitle')+'</label>' +
                '<input type="number" id="salesLogAmount" name="salesLogAmount" placeholder="1000" class="form-control">' +
                '</div>' +
                '<div class="form-group text-left">' +
                '<label for="salesLogSoldPrice">'+i18next.t('salesLogSection.soldPrice.colName')+'</label>' +
                '<input type="number" id="salesLogSoldPrice" name="salesLogSoldPrice" placeholder="0.00000400" class="form-control">' +
                '</div>' +
                '<div class="form-group text-left">' +
                '<label for="salesLogAvgPrice">'+i18next.t('salesLogSection.boughtPrice.colName')+'</label>' +
                '<input type="number" id="salesLogAvgPrice" name="salesLogAvgPrice" placeholder="0.00000400" class="form-control">' +
                '</div>';
            if(isLeverageExchange) {
                html +=
                    '<div class="form-group text-left">' +
                    '<label for="sellLogLeverage">'+i18next.t('addRecordModal.leverage')+'</label>' +
                    '<input type="number" id="sellLogLeverage" name="sellLogLeverage" placeholder="100" class="form-control">' +
                    '</div>';
            }
        }


        Swal.fire({
            title: buyOrSell === 'buy' ? i18next.t('alertMsgs.buyRecord') : i18next.t('alertMsgs.salesRecord'),
            type: "warning",
            html: html,
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.addRecord'),
            reverseButtons: true,
            preConfirm: () => {
                checkRole();
                if(buyOrSell === 'buy' && !supportAccess) {
                    if (document.getElementById('buyLogCurrencyPair').value && document.getElementById('buyLogAmount').value && document.getElementById('buyLogAvgPrice').value && (isLeverageExchange ? document.getElementById('buyLogLeverage').value : true)) {
                        Service.addBuyOrSalesRecord({
                            'buyLogCurrencyPair': document.getElementById('buyLogCurrencyPair').value,
                            'buyLogAmount': document.getElementById('buyLogAmount').value,
                            'buyLogAvgPrice': document.getElementById('buyLogAvgPrice').value,
                            'buyLogLeverage': isLeverageExchange ? document.getElementById('buyLogLeverage').value : 0
                        }, buyOrSell, showError)
                    } else {
                        Swal.showValidationMessage(i18next.t('alertMsgs.filledProperties'));
                    }
                } else if(buyOrSell === 'sell' && !supportAccess) {
                    if(document.getElementById('salesLogCurrencyPair').value && document.getElementById('salesLogAmount').value && document.getElementById('salesLogSoldPrice').value && document.getElementById('salesLogAvgPrice').value && (isLeverageExchange ? document.getElementById('sellLogLeverage').value : true)) {
                        Service.addBuyOrSalesRecord({
                            'salesLogCurrencyPair': document.getElementById('salesLogCurrencyPair').value,
                            'salesLogAmount': document.getElementById('salesLogAmount').value,
                            'salesLogSoldPrice': document.getElementById('salesLogSoldPrice').value,
                            'salesLogAvgPrice': document.getElementById('salesLogAvgPrice').value,
                            'sellLogLeverage': isLeverageExchange ? document.getElementById('sellLogLeverage').value : 0
                        }, buyOrSell, showError)
                    } else {
                        Swal.showValidationMessage(i18next.t('alertMsgs.filledProperties'));
                    }
                } else if(supportAccess) {
                    Swal.fire(i18next.t('alertMsgs.notAllowed'));
                }
            }
        })
    }
    function buyModal(e) {
        let isMarketOrderSupported = typeof RouteHelper.getServerData().settings === 'undefined' ? true : RouteHelper.getServerData().settings.isMarketOrderSupported;
        let buyOrSell = e.target.dataset.buyOrSell;
        let selectPtDefaultOrderType = typeof RouteHelper.getServerData().accountsLog === 'undefined' ? true : RouteHelper.getServerData().accountsLog.BUY_ORDER_TYPE_OR_TIME;
        let testMode = typeof RouteHelper.getServerData().settings === 'undefined' ? true : RouteHelper.getServerData().settings.testMode;

        let html = '<div class="form-group">' +
            '<label for="buyAmountPercentageSwal">'+i18next.t('alertMsgs.amountInPercentage', { 'order': buyOrSell.charAt(0).toUpperCase() + buyOrSell.slice(1) })+'</label>' +
            '<input type="number" id="buyAmountPercentageSwal" name="buyAmountPercentageSwal" min="1" placeholder="100" value="100" class="form-control text-center w-50 m-auto">' +
            '</div>';

        if(isMarketOrderSupported && !testMode) {
            html += '<div class="form-group">' +
                '<label for="orderTypeSwal">'+i18next.t('alertMsgs.selectOrderType')+'</label>' +
                '<select name="orderTypeSwal" id="orderTypeSwal" required class="form-control w-50 m-auto">' +
                '<option value="">'+i18next.t('alertMsgs.selectOrderType')+'</option>' +
                '<option '+ (selectPtDefaultOrderType === "IOC" ? "selected" : "") +' value="IOC">IOC</option>' +
                '<option '+ (selectPtDefaultOrderType === "MARKET" ? "selected" : "") +' value="MARKET">Market</option>' +
                '</select>' +
                '</div>';

            Swal.fire({
                title: buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?',
                text: '' + i18next.t('alertMsgs.sureTo') + e.target.dataset.buyOrSell + ' ' + e.target.dataset.pair + '?',
                type: 'warning',
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn') + " " + e.target.dataset.pair,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: buyOrSell.toUpperCase(),
                reverseButtons: true,
                html: html,
                preConfirm: () => {
                    checkRole();
                    if(!supportAccess && document.getElementById('orderTypeSwal').value && document.getElementById('buyAmountPercentageSwal').value) {
                        Service.buyPair(buyOrSell, e.target.dataset.pair, document.getElementById('orderTypeSwal').value, document.getElementById('buyAmountPercentageSwal').value, showError);
                        (function spinnersInBadges() {
                            let badges = document.getElementsByClassName("records-count");
                            Array.prototype.forEach.call(badges, function(badge) {
                                badge.innerHTML = '<i class="fa fa-spinner fa-spin" aria-hidden="true"></i>';
                            });
                        })();
                    } else if(supportAccess) {
                        Swal.fire(i18next.t('alertMsgs.notAllowed'));
                    } else {
                        Swal.showValidationMessage(i18next.t('alertMsgs.filledProperties'));
                    }
                }
            })
        } else {
            Swal.fire({
                title: buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?',
                text: '' + i18next.t('alertMsgs.sureTo') + buyOrSell + ' ' + e.target.dataset.pair + '?',
                type: 'warning',
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn') + " " + e.target.dataset.pair,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: buyOrSell.toUpperCase(),
                reverseButtons: true,
                html: html,
                preConfirm: () => {
                    checkRole();
                    if(!supportAccess && document.getElementById('buyAmountPercentageSwal').value) {
                        Service.buyPair(buyOrSell, e.target.dataset.pair, 'IOC', document.getElementById('buyAmountPercentageSwal').value, showError);
                        (function spinnersInBadges() {
                            let badges = document.getElementsByClassName("records-count");
                            Array.prototype.forEach.call(badges, function(badge) {
                                badge.innerHTML = '<i class="fa fa-spinner fa-spin" aria-hidden="true"></i>';
                            });
                        })();
                    } else if(supportAccess) {
                        Swal.fire(i18next.t('alertMsgs.notAllowed'));
                    } else {
                        Swal.showValidationMessage(i18next.t('alertMsgs.filledProperties'));
                    }
                }
            })
        }
    }

    function sellModal(e) {
        let isMarketOrderSupported = typeof RouteHelper.getServerData().settings === 'undefined' ? true : RouteHelper.getServerData().settings.isMarketOrderSupported;
        let buyOrSell = e.target.dataset.buyOrSell;
        let selectPtDefaultOrderType = typeof RouteHelper.getServerData().accountsLog === 'undefined' ? true : RouteHelper.getServerData().accountsLog.SELL_ORDER_TYPE_OR_TIME;
        let testMode = typeof RouteHelper.getServerData().settings === 'undefined' ? true : RouteHelper.getServerData().settings.testMode;


        let html = '<div class="form-group">' +
            '<label for="sellAmountPercentageSwal">'+i18next.t('alertMsgs.amountInPercentage', { 'order': buyOrSell.charAt(0).toUpperCase() + buyOrSell.slice(1) })+'</label>' +
            '<input type="number" id="sellAmountPercentageSwal" name="sellAmountPercentageSwal" min="1" max="100" placeholder="100" value="100" class="form-control text-center w-50 m-auto">' +
            '</div>';


        if(isMarketOrderSupported && !testMode) {
            html += '<div class="form-group">' +
                '<label for="orderTypeSwal">'+i18next.t('alertMsgs.selectOrderType')+'</label>' +
                '<select name="orderTypeSwal" id="orderTypeSwal" required class="form-control w-50 m-auto">' +
                '<option value="">'+i18next.t('alertMsgs.selectOrderType')+'</option>' +
                '<option '+ (selectPtDefaultOrderType === "IOC" ? "selected" : "") +' value="IOC">IOC</option>' +
                '<option '+ (selectPtDefaultOrderType === "MARKET" ? "selected" : "") +' value="MARKET">Market</option>' +
                '</select>' +
                '</div>';

            Swal.fire({
                title: buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?',
                text: '' + i18next.t('alertMsgs.sureTo') + e.target.dataset.buyOrSell + ' ' + e.target.dataset.pair + '?',
                type: 'warning',
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn') + " " + e.target.dataset.pair,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: buyOrSell.toUpperCase(),
                reverseButtons: true,
                html: html,
                preConfirm: () => {
                    checkRole();
                    if(!supportAccess && document.getElementById('orderTypeSwal').value && document.getElementById('sellAmountPercentageSwal').value) {
                        Service.sellPair(buyOrSell, e.target.dataset.pair, document.getElementById('orderTypeSwal').value, document.getElementById('sellAmountPercentageSwal').value, showError);
                        (function spinnersInBadges() {
                            let badges = document.getElementsByClassName("records-count");
                            Array.prototype.forEach.call(badges, function(badge) {
                                badge.innerHTML = '<i class="fa fa-spinner fa-spin" aria-hidden="true"></i>';
                            });
                        })();
                    } else if(supportAccess) {
                        Swal.fire(i18next.t('alertMsgs.notAllowed'));
                    } else {
                        Swal.showValidationMessage(i18next.t('alertMsgs.filledProperties'));
                    }
                }
            })
        } else {
            Swal.fire({
                title: buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?',
                text: '' + i18next.t('alertMsgs.sureTo') + buyOrSell + ' ' + e.target.dataset.pair + '?',
                type: 'warning',
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn') + " " + e.target.dataset.pair,
                confirmButtonColor: '#DD6B55',
                confirmButtonText: buyOrSell.toUpperCase(),
                reverseButtons: true,
                html: html,
                preConfirm: () => {
                    checkRole();
                    if(!supportAccess && document.getElementById('sellAmountPercentageSwal').value) {
                        Service.sellPair(buyOrSell, e.target.dataset.pair, 'IOC', document.getElementById('sellAmountPercentageSwal').value, showError);
                        (function spinnersInBadges() {
                            let badges = document.getElementsByClassName("records-count");
                            Array.prototype.forEach.call(badges, function(badge) {
                                badge.innerHTML = '<i class="fa fa-spinner fa-spin" aria-hidden="true"></i>';
                            });
                        })();
                    } else if(supportAccess) {
                        Swal.fire(i18next.t('alertMsgs.notAllowed'));
                    } else {
                        Swal.showValidationMessage(i18next.t('alertMsgs.filledProperties'));
                    }
                }
            })
        }
    }

    function deleteEntry(e) {
        Swal.fire({
            title: i18next.t('deleteEntry.title'),
            text: i18next.t('deleteEntry.text'),
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('deleteEntry.confirm'),
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if(result.value && !supportAccess) {
                Service.deleteEntry(e.target.dataset.position, showError);
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function buyOrSellModal(e) {
        if (e.target.classList.contains('cancel-pending')) {
            Swal.fire({
                title: e.target.dataset.buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?',
                text: i18next.t('alertMsgs.cancelOrderConfirm', {
                    orderNumber: e.target.dataset.orderNumber,
                    pair: e.target.dataset.pair
                }),
                type: "warning",
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.exit'),
                confirmButtonColor: '#DD6B55',
                confirmButtonText: i18next.t('alertMsgs.cancelOrderBtn', {
                    orderNumber: e.target.dataset.orderNumber
                }),
                reverseButtons: true,
            }).then(result => {
                checkRole();
                if(result.value && !supportAccess) {
                    return result.value ? Service.cancelPending(e.target.dataset.pair, e.target.dataset.orderNumber, showError) : null;
                } else if(supportAccess) {
                    Swal.fire(i18next.t('alertMsgs.notAllowed'));
                }
            });
        } else if(e.target.classList.contains('pending-btn')) {
            let html = '<div class="form-group">' +
                '<label for="pendingAvgPrice">'+i18next.t('alertMsgs.pendingPlaceholder', { pair: e.target.dataset.pair })+'</label>' +
                '<input type="number" id="pendingAvgPrice" name="pendingAvgPrice" min="1" max="100" placeholder="100" value="'+ e.target.dataset.avgPrice +'" class="form-control text-center w-50 m-auto">' +
                '</div>' +
                '<div class="form-group">' +
                '<label for="pendingAmount">'+i18next.t('alertMsgs.pendingAmount')+'</label>' +
                '<input type="number" id="pendingAmount" name="pendingAmount" min="1" max="100" placeholder="100" value="100" class="form-control text-center w-50 m-auto">' +
                '</div>';
            Swal.fire({
                title: i18next.t('alertMsgs.pendingTitle', {
                    pair: e.target.dataset.pair
                }),
                text: i18next.t('alertMsgs.pendingText'),
                type: "warning",
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
                confirmButtonColor: '#DD6B55',
                confirmButtonText: i18next.t('alertMsgs.pendingConfirm'),
                reverseButtons: true,
                html: html,
                preConfirm: () => {
                    checkRole();
                    if(!supportAccess && document.getElementById('pendingAvgPrice').value && document.getElementById('pendingAmount').value) {
                        Service.enterPending(
                            e.target.dataset.pair,
                            document.getElementById('pendingAvgPrice').value,
                            document.getElementById('pendingAmount').value,
                            e.target.dataset.avgPrice,
                            showError);
                    } else if(supportAccess) {
                        Swal.fire(i18next.t('alertMsgs.notAllowed'));
                    } else {
                        Swal.showValidationMessage(i18next.t('alertMsgs.filledProperties'));
                    }
                }
            })
        } else if(e.target.classList.contains('boughtCost-btn')) {
            let activeConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];

            Swal.fire({
                title: i18next.t('alertMsgs.boughtCostTitle', {
                    pair: e.target.dataset.pair
                }),
                text: i18next.t('alertMsgs.boughtCostText'),
                type: 'warning',
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
                confirmButtonColor: '#DD6B55',
                confirmButtonText: i18next.t('alertMsgs.submitBtn'),
                reverseButtons: true,
                input: 'text',
                inputPlaceholder: i18next.t('alertMsgs.boughtCostPlaceholder', {
                    pair: e.target.dataset.pair
                }),
                inputValue: e.target.dataset.avgPrice,
                inputValidator: (value) => {
                    if (!value) {
                        return '<b>' + i18next.t('alertMsgs.insertValue') + '</b>';
                    }
                }
            }).then(result => {
                let boughtCost = e.target.dataset.pair + '_bought_price='+result.value
                checkRole();
                if(result.value && !supportAccess) {
                    Service.saveConfigFile("HOTCONFIG", boughtCost, activeConfig, showError);
                    Swal.fire(i18next.t('alertMsgs.sent') + " " + result.value + i18next.t('alertMsgs.to') + activeConfig + '.');
                } else if(supportAccess) {
                    Swal.fire(i18next.t('alertMsgs.notAllowed'));
                }
            })
        }
    }

    function toolTipModal(e) {
        let setting = e.target.getAttribute('for');
        let settingKeys = Object.keys(tooltips);
        let lowerKeys = settingKeys.join('|').toLowerCase().split('|');

        let showSetting = lowerKeys.indexOf(setting);

        if (tooltips[settingKeys[showSetting]]) {
            Swal.fire({
                title: e.target.innerHTML,
                text: i18next.t('alertMsgs.setting') + e.target.getAttribute('for') + "\n\n" + tooltips[settingKeys[showSetting]].toolTip
            });
        } else if(supportAccess) {
            Swal.fire(i18next.t('alertMsgs.noTip'))
        }
    }

    function publishConfigModal() {
        var activeConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];
        Swal.fire({
            text: i18next.t('alertMsgs.shareConfirm', {
                activeconfig: activeConfig
            }),
            type: "question",
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.share'),
            reverseButtons: true,
        }).then(result => {
            checkRole();
            if (result.value && !supportAccess) {
                Service.publishActiveSetting();
            } else if(supportAccess) {
                Swal.fire(i18next.t('alertMsgs.notAllowed'));
            }
        });
    }

    function blackListModal() {
        const settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        const eCfg = settingsObj['editingConfig']
        let newdiv = document.createElement('DIV')
        newdiv.classList = "d-flex justify-content-center"
        let blackListNav = document.createElement('DIV')
        blackListNav.classList = "d-flex justify-content-center p-t-0 m-0"
        let iconarr = ['fa fa-list listblack blacklistb', 'fa fa-list listwhite blacklistw', 'fa fa-adjust listwhite blacklistbw']
        iconarr.map(function(icons) {
            let icon = document.createElement('I')
            icon.classList = icons;
            icon.style.cursor = 'pointer'
            if (icons.includes('blacklistw')) {
                icon.style.color = 'white'

                icon.setAttribute("title", "Whitelist")
            }
            if (icons.includes('blacklistb')) {
                icon.style.color = 'black'

                icon.setAttribute("title", "Blacklist")
            }
            if (icons.includes('blacklistbw')) {
                icon.style.color = 'white'

                icon.setAttribute("title", "All")
            }
            icon.style.fontSize = '30px';
            icon.style.padding = '0px 50px 15px 50px';
            blackListNav.appendChild(icon)
        })
        let col1 = document.createElement('DIV')
        col1.classList = "col card-box"
        col1.style.height = "55vh"
        col1.appendChild(blackListNav)
        col1.appendChild(fillBlackList())
        newdiv.appendChild(col1)
        Swal.fire({
            html: newdiv,
            showCancelButton: true,
            cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
            confirmButtonColor: '#DD6B55',
            confirmButtonText: i18next.t('alertMsgs.save'),
            reverseButtons: true,
        }).then(result => {
            if (result.value) {
                saveForm('PAIRS', true)
            } else {
                storeConfigLoadForEdit(eCfg)
            }
        });
    }

    return {
        switchConfigModal,
        hotModal,
        resetBotModal,
        removeConfigModal,
        newConfigNameModal,
        buyOrSellModal,
        toolTipModal,
        publishConfigModal,
        blackListModal,
        panicSellModal,
        hotConfigModal,
        addBuyOrSalesRecord,
        reserveAmount,
        releaseAmount,
        cancelReversal,
        sellModal,
        buyModal,
        deleteEntry,
    };
})();
/***********************************/

/*
 ************* eventListeners ********
 *
 */
document.addEventListener('change', function(event) {
    if (event.target.id === 'pairsmenu') {
        //console.log(event.target.value)
        switchConfigFormCoinSpecific(event.target.value);
        //allSets();
    }
    if (event.target.classList.contains('config-dropdown')) {

        storeConfigLoadForEdit(event.target.value)
    }
    if (event.target.id === 'switchActiveConfig') {
        Modals.switchConfigModal(event);
    }
    if (event.target.classList.contains('config-input')) {
        let panicRegex = new RegExp(/.*_panic_sell_enabled/, 'i')
        if (event.target.value.includes(',')) {
            event.target.title = event.target.value
        }
        // Only show Panic Sell modal when switching from FALSE to TRUE
        if (event.target.id.match(panicRegex) && event.target.checked === true) {
            Modals.panicSellModal(event.target);
        } else {
            changeSettingHandler(event.target);
        }
    }
}, false);

document.addEventListener('mousedown', function(event) {
    checkRole();
    if (event.target.classList.contains('acetab')) {

        if (unsavedChangesCheck()) {
            event.preventDefault()

            Swal.fire({
                text: i18next.t('alertMsgs.unsavedChangesOnThisTab'),
                type: "warning",
                showCancelButton: true,
                cancelButtonText: i18next.t('alertMsgs.cancelBtn'),
                confirmButtonColor: '#DD6B55',
                confirmButtonText: i18next.t('alertMsgs.ok'),
                reverseButtons: true,

            }).then(result => {
                if (result.value && !supportAccess) {
                    return aceSave().then((result) => {
                        if (result === 'success') {
                            loadACE(event.target.dataset.settingType);
                            event.target.click();
                            Swal.close();
                        }
                    })
                } else {
                    Swal.fire(i18next.t('alertMsgs.cancelled'), i18next.t('alertMsgs.fileStillUnsaved'), "error");
                }
            })
        }
    }
})

document.addEventListener('mouseup', function(event) {
    if (event.target.id === 'blackListButton') {
        Modals.blackListModal();
    }
    if (event.target.classList.contains('blackListItem')) {
        let param;
        let paramVal = '';
        if (event.target.classList.contains('blMode')) {
            param = event.target.innerHTML + "_trading_enabled"
            if (!event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingON')
                event.target.classList.add('tradingOFF')
                paramVal = 'false';
            } else if (event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingOFF')
                event.target.classList.add('tradingON')
                paramVal = 'true';
            }
        } else if (event.target.classList.contains('epMode')) {
            param = 'enabled_pairs';
            let epname = new RegExp(/enabled_pairs/, 'i');
            let eCfg = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['editingConfig'];
            let ep = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['files'][eCfg]['PAIRS']['enabled_pairs'];
            ep = ep.toUpperCase().split(',').map(Function.prototype.call, String.prototype.trim);
            if (!event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingON')
                event.target.classList.add('tradingOFF')
                ep = ep.filter(e => e !== event.target.innerHTML);
                paramVal = ep.join(',')
            } else if (event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingOFF')
                event.target.classList.add('tradingON')
                ep.push(event.target.innerHTML);

                paramVal = ep.join(',');
            }

        }

        changeSetting('PAIRS', param, paramVal)
    }
    if (event.target.classList.contains('listblack') || event.target.classList.contains('listwhite')) {
        if (event.target.classList.contains('blacklistb')) {
            d.qSA('.tradingON').forEach(
                function(tOffel) {
                    tOffel.style.display = 'none';
                }
            )
            d.qSA('.tradingOFF').forEach(
                function(tOffel) {
                    tOffel.style.display = 'block';
                }
            )

        } else if (event.target.classList.contains('blacklistw')) {
            d.qSA('.tradingOFF').forEach(
                function(tOffel) {
                    tOffel.style.display = 'none';
                }
            )
            d.qSA('.tradingON').forEach(
                function(tOffel) {
                    tOffel.style.display = 'block';
                }
            )

        } else if (event.target.classList.contains('blacklistbw')) {
            d.qSA('.tradingOFF').forEach(
                function(tOffel) {
                    tOffel.style.display = 'block';
                }
            )
            d.qSA('.tradingON').forEach(
                function(tOffel) {
                    tOffel.style.display = 'block';
                }
            )
        }
    }
    if (event.target.id === 'basic-hotconfig') {
        Modals.hotModal()
    }
    if(event.target.id === 'HCBalanceBtn' || event.target.id === 'HCSetBuyTimesBtn' || event.target.id === 'HCBoughtPriceBtn') {
        let command = ''
        switch(event.target.id) {
            case 'HCBalanceBtn':
                if (document.getElementById('HCBalance').value === "" || document.getElementById('HCBalance').value.indexOf(',') !== -1) {
                    toastr.error(i18next.t('hotConfig.balanceError'))
                    return;
                } else {
                    command = 'test_mode_balance = ' + document.getElementById("HCBalance").value
                }

                break;
            case 'HCSetBuyTimesBtn':
                if (document.getElementById('HCSetBuyTimesPairs').value === "" || document.getElementById('HCSetBuyTimes').value === "") {
                    toastr.error(i18next.t('hotConfig.buyTimesError'))
                    return;
                } else {
                    command = document.getElementById("HCSetBuyTimesPairs").value + '_DCA_set_buy_times = ' + document.getElementById("HCSetBuyTimes").value
                }
                break;
            case 'HCBoughtPriceBtn':
                if (document.getElementById('HCBoughtPricePairs').value === "" || document.getElementById('HCBoughtPrice').value === "" || document.getElementById('HCBoughtPrice').value.indexOf(',') !== -1) {
                    toastr.error(i18next.t('hotConfig.boughtPriceError'))
                    return;
                } else {
                    command = document.getElementById("HCBoughtPricePairs").value + '_bought_price = ' + document.getElementById("HCBoughtPrice").value
                }
                break;
            default:
                break;
        }
        Modals.hotConfigModal(command)
    }
    if (event.target.id === 'saveButton' || event.target.classList.contains('save-config-form')) {
        $('#config-save-loader').css('visibility', $('#config-save-loader').css('visibility') === 'hidden' ? 'visible' : 'hidden');


        let saveThrottled = RateLimit(saveForm, 1000);
        ['PAIRS', 'DCA', 'INDICATORS'].forEach((file) => saveThrottled(file));


    }
    if (event.target.classList.contains('save-config')) {
        checkRole();
        if(!supportAccess) {
            $('#config-save-loader-ace').css('visibility', $('#config-save-loader-ace').css('visibility') === 'hidden' ? 'visible' : 'hidden');
            aceSave();
        } else {
            Swal.fire(i18next.t('alertMsgs.notAllowed'));
        }

    }
    if(event.target.classList.contains('save-pft-config-app')) {
        $('#PTFConfigEditorAppLoading').css('visibility', $('#PTFConfigEditorAppLoading').css('visibility') === 'hidden' ? 'visible' : 'hidden');
        let editor = DomHelper.getGlobalEditor('PTFConfigEditorApp')
        let configFile = editor.getValue();
        editor.getSession().setMode("ace/mode/json");
        checkRole();
        Service.saveConfigFile('PTFEEDER', configFile, 'APP', showError).done(function(jqXHR, data) {
            if(data === 'success') {
                notSaved('hide');
                toastr.success(i18next.t('constantMsgs.configSuccess'));
                $('#PTFConfigEditorAppLoading').css('visibility', $('#PTFConfigEditorAppLoading').css('visibility') === 'hidden' ? 'visible' : 'hidden');
            } else if (data !== 'success') {
                toastr.info(i18next.t('constantMsgs.ajaxError'));
            }
        });

    }
    if(event.target.classList.contains('save-pft-config-host')) {
        $('#PTFConfigEditorHostLoading').css('visibility', $('#PTFConfigEditorHostLoading').css('visibility') === 'hidden' ? 'visible' : 'hidden');
        let editor = DomHelper.getGlobalEditor('PTFConfigEditorHost')
        let configFile = editor.getValue();
        editor.getSession().setMode("ace/mode/json");
        checkRole();
        Service.saveConfigFile('PTFEEDER', configFile, 'HOST', showError).done(function(jqXHR, data) {
            if(data === 'success') {
                notSaved('hide');
                toastr.success(i18next.t('constantMsgs.configSuccess'));
                $('#PTFConfigEditorHostLoading').css('visibility', $('#PTFConfigEditorHostLoading').css('visibility') === 'hidden' ? 'visible' : 'hidden');
            } else if (data !== 'success') {
                toastr.info(i18next.t('constantMsgs.ajaxError'));
            }
        });
    }
    if (event.target.classList.contains('btnReset')) {
        if (event.target.classList.contains('disabled')) {
            return;
        }
        Modals.resetBotModal();
    }
    if (event.target.classList.contains('formstabs')) {
        let obj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
        let fileName = event.target.dataset.settingType;
        obj['editingFile'] = fileName
        updateGuiConfigFields(fileName)
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), obj)
    }
    if (event.target.classList.contains('acetab')) {

        let obj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
        obj['editingFile'] = event.target.dataset.settingType
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), obj)
        loadACE(event.target.dataset.settingType);

    }
    if (event.target.classList.contains('removeConfig')) {
        Modals.removeConfigModal();
    }
    if (event.target.classList.contains('new-config-name')) {
        Modals.newConfigNameModal();
    }
    if (event.target.classList.contains('buy-or-sell-btn')) {
        Modals.buyOrSellModal(event);
    }
    if(event.target.classList.contains('open-btn')) {
        Modals.buyModal(event);
    }
    if(event.target.classList.contains('close-btn')) {
        Modals.sellModal(event);
    }
    if (event.target.classList.contains('pending-btn')) {
        Modals.buyOrSellModal(event);
    }
    if (event.target.classList.contains('cancel-pending')) {
        Modals.buyOrSellModal(event);
    }
    if (event.target.classList.contains('boughtCost-btn')) {
        Modals.buyOrSellModal(event);
    }
    if (event.target.classList.contains('control-label')) {
        Modals.toolTipModal(event);
    }
    if (event.target.classList.contains('share-config')) {
        Modals.publishConfigModal();
    }
    if (event.target.classList.contains('backup-config')) {
        backup();
    }
    if (event.target.classList.contains('plusminus')) {
        plusMinusHandler(event.target)
    }
    if (event.target.classList.contains('plusminusi')) {
        plusMinusHandler(event.target.parentElement)
    }
    if(event.target.classList.contains('add-buy-record') || event.target.classList.contains('add-sales-record')) {
        Modals.addBuyOrSalesRecord(event)
    }
    if(event.target.classList.contains('reserve-btn')) {
        Modals.reserveAmount(event);
    }
    if(event.target.classList.contains('release-btn')) {
        Modals.releaseAmount(event);
    }
    if(event.target.classList.contains('cancel-reversal')) {
        Modals.cancelReversal(event);
    }
    if(event.target.classList.contains('delete-entry')) {
        Modals.deleteEntry(event);
    }


}, false);
/***********************************/

/*
 ************* Initialization ********
 * Fired in script.js
 */
function configInit() {

    storeConfigFiles();
    enableTestModeButtons();
    d.qSA('.control-label').forEach(function(x) {
        x.classList.add('tool-tip')
    })
}
/***********************************/
function enableEditor(tof) {
    let editor = DomHelper.getGlobalEditor('PBConfigEditor');
    tof ? editor.container.style.opacity = 1 : editor.container.style.opacity = 0.3;
    tof ? editor.container.style.pointerEvents = "all" : editor.container.style.pointerEvents = "none"
    tof ? editor.renderer.setStyle("disabled", false) : editor.renderer.setStyle("disabled", true)
    tof ? editor.focus() : editor.blur();
    tof ? editor.textInput.getElement().disabled = false : editor.textInput.getElement().disabled = true;

    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    if (!tof && settingsObj != null && settingsObj['editingFile'] !== 'HOTCONFIG') {
        silent = true;
        editor.session.setValue('Loading...', -1);
        silent = false;
    }

}

function unsavedChangesCheck() {
    let saveEl = d.qS('.show-save-message');
    return saveEl.classList.contains('not-saved')
}

function aceSave() {
    return new Promise(function(resolve, reject) {
        let editor = DomHelper.getGlobalEditor('PBConfigEditor');
        let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        let filename = settingsObj['editingFile'];
        let configName = settingsObj['editingConfig'];
        let updatedData = editor.getValue();
        esvJSON(updatedData).then(function(output) {
            settingsObj['files'][configName][filename] = output;
            LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        });
        Service.saveConfigFile(filename, updatedData, configName, showError).done(function(jqXHR, data) {
            // console.log(data)
            if (data === 'success') {
                notSaved('hide');
                toastr.success(i18next.t('constantMsgs.configSuccess'));
                $('#config-save-loader-ace').css('visibility', $('#config-save-loader-ace').css('visibility') === 'hidden' ? 'visible' : 'hidden');
            } else if (data !== 'success') {
                toastr.info(i18next.t('constantMsgs.ajaxError'));
            }
            resolve(data)
        });
    })
}

function plusMinusHandler(plusMinus) {
    if (plusMinus.classList.contains('badge-danger')) {
        plusMinus.classList.remove('badge-danger');
        plusMinus.classList.add('badge-success');
        plusMinus.innerHTML = '<span class="fa fa-plus plusminusi"></span>';
        let classNameList =
            plusMinus.parentElement.parentElement
                .getElementsByClassName('config-input');
        for (let i = 0; i < classNameList.length; i++) {
            el = classNameList[i];
            el.disabled = true;
            changeSetting(String(el.dataset.settingType), String(el.id), "remove")
            if (el.tagName == 'SELECT') {
                el.value = "Choose...";
            } else {
                el.value = '';
            }
            notSaved('show');
        }
    } else if (plusMinus.classList.contains('badge-success')) {
        plusMinus.innerHTML = '<span class="fa fa-minus plusminusi"></span>';
        plusMinus.classList.remove('badge-success');
        plusMinus.classList.add('badge-danger');
        let classNameList =
            plusMinus.parentElement.parentElement
                .getElementsByClassName('config-input');
        for (let i = 0; i < classNameList.length; i++) {
            el = classNameList[i];
            el.disabled = false;
        }
    }
}

function togglePlusMinus() {
    let minusButtons = d.qSA('.plusminus'),
        result;
    for (let i = 0; i < minusButtons.length; i++) {
        result = minusButtons[i];
        let classNameList = result.parentElement.parentElement.parentElement.getElementsByClassName('config-input');
        if (!classNameList[1].disabled) {
            result.classList.remove('badge-success');
            result.classList.add('badge-danger');
            result.innerHTML = '<span class="fa fa-minus plusminusi"></span>';
        } else {
            result.classList.remove('badge-danger');
            result.classList.add('badge-success');
            result.innerHTML = '<span class="fa fa-plus plusminusi"></span>';
        }
    }
}

function enableTestModeButtons() {
    Service.getPropertiesLog().then(function(x) {
        let testy = d.qSA('.testmode');
        if (x.testMode) {
            Array.prototype.forEach.call(testy, function(el) {
                el.classList.remove('disabled')
            })
        } else {
            Array.prototype.forEach.call(testy, function(el) {
                el.classList.add('disabled')
            })
        }
    })
}

function esvJSON(esv) {
    return new Promise(function(resolve, reject) {
        esv = Array.isArray(esv) ? esv.join('\n') : esv;
        let lines = esv.split("\n");
        let result = [];
        for (let i = 0; i < lines.length; i++) {
            let obj = [];
            let currentLine = lines[i].trim();

            if (currentLine.startsWith('#') || currentLine === "") {
                obj.push("comment-" + i, currentLine);
                result.push(obj);
            } else if (lines[i].indexOf('=') !== -1) {
                obj.push(lines[i].split("=", 2)[0].trim(), lines[i].split("=").slice(1).join("=").trim())
                result.push(obj);
            } else {
                obj.push(lines[i]);
                result.push(obj);
            }
        }
        result = result.reduce(function(p, c) {
            p[c[0]] = c[1];
            return p;
        }, {});
        resolve(result); //JSON
    })
}

function storeConfigFiles() {
    let storedObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let settingsObj = {};
    $.when(Service.getMiscLog(), Service.getPropertiesLog()).done(function(miscLog, propertyLog) {
        settingsObj.availableConfigs = JSON.parse(propertyLog[0].availableConfigs);
        settingsObj.maxConfigsAllowed = JSON.parse(propertyLog[0].maxConfigsAllowed);
        settingsObj.configName = propertyLog[0].activeConfig;
        settingsObj.market = miscLog[0].market;
        settingsObj.exchange = miscLog[0].exchange;

        let containsConfig = storedObj != null && $.inArray(storedObj['editingConfig'], settingsObj.availableConfigs) != -1;
        (!containsConfig) ? settingsObj.editingConfig = propertyLog[0].activeConfig: settingsObj.editingConfig = storedObj['editingConfig'];
        (!containsConfig) ? settingsObj.editingFile = 'PAIRS': settingsObj.editingFile = storedObj['editingFile'];
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        storeConfigLoadForEdit(settingsObj.editingConfig)
    })
}

function storeConfigLoadForEdit(configName) {
    enableEditor(false)
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let activeconfig = settingsObj['configName']
    let editingFile = settingsObj['editingFile']
    settingsObj['editingConfig'] = configName;
    let deletebtns = d.gEBCN('removeConfig');
    let savebtns = d.gEBCN('save-config');
    let sharebtn = d.gEBCN('share-config');
    let $configSwitcherContainer = $('.config-switcher-container');
    LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj)
    settingsObj['files'] = {};
    settingsObj['files'][configName] = {}

    testarray = []
    configFiles.forEach(function(filename) {
        settingsObj['files'][configName][filename] = {};
        testarray.push(Service.getConfigFile(filename, configName)
            .done(function(data) {
                // Returning if data is empty string.
                if (!data) {
                    return;
                }
                data = JSON.parse(data);
                data ? esvJSON(data).then(function(output) {
                        settingsObj['files'][configName][filename] = output;
                        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
                        eachSetting(output);
                        if (editingFile === filename) {
                            loadACE(filename)

                        }
                    }) :
                    toastr.info(i18next.t('constantMsgs.ajaxError'));
            }));

    });
    Promise.all(testarray).then(() => {
        enableEditor(true)
    }).catch(() => {
        // all requests finished but one or more failed
        console.log('caught error')
    })
    if (activeconfig === configName) {
        Array.prototype.map.call(deletebtns, function(x) {
            x.style.display = "none"
        })
        Array.prototype.map.call(sharebtn, function(btns) {
            btns.style.display = "inline-block"
        })
        Array.prototype.map.call(savebtns, function(x) {
            x.style.display = "inline-block"
        })
        $configSwitcherContainer.addClass('active-config-container')
    } else if (configName.startsWith("public-")) {
        Array.prototype.map.call(deletebtns, function(x) {
            x.style.display = "none"
        })
        Array.prototype.map.call(savebtns, function(x) {
            x.style.display = "none"
        })
    } else {
        Array.prototype.map.call(deletebtns, function(x) {
            x.style.display = "inline-block"
        });
        Array.prototype.map.call(sharebtn, function(btns) {
            btns.style.display = "none"
        })
        Array.prototype.map.call(savebtns, function(x) {
            x.style.display = "inline-block"
        })
        $configSwitcherContainer.removeClass('active-config-container')
    }
    d.gEBI('configDropdown2').value = configName;
}


function toggleConfigVisibility() {
    let aceContainer = d.gEBI('configurationContainer');
    aceContainer.style.display = 'block';
}

function switchConfigFormCoinSpecific(pair) {


    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
    d.qSA('.config-input').forEach(function(x) {
        if (d.qS('label[for=' + x.id + ']')) {
            d.qS('label[for=' + x.id + ']').htmlFor = x.getAttribute('id').replace(currentlyEditing, pair)
            x.id = x.getAttribute('id').replace(currentlyEditing, pair);
            x.name = x.getAttribute('id').replace(currentlyEditing, pair);
        }

    });
    currentlyEditing = pair;

    allSets();
    // storeConfigLoadForEdit(settingsObj['editingConfig'])
}

function switchActiveConfig(configName) {
    Service.switchConfigFile(configName);
}

function removeConfigFile(configName) {
    Service.removeConfigFile(configName);
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
    let currentConfig = settingsObj['configName'];
    let availableConfigs = settingsObj['availableConfigs']
    let filteredConfigList = availableConfigs.filter(
        function(item) {
            return item !== configName
        });
    settingsObj['availableConfigs'] = filteredConfigList;
    settingsObj['editingConfig'] = currentConfig
    LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
    storeConfigLoadForEdit(currentConfig);
}

function removeConfigFileHandler() {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
    let currentConfig = settingsObj['configName'];
    let editConfig = settingsObj['editingConfig'];
    if (editConfig !== currentConfig) {
        removeOption('#configDropdown2', editConfig);
        removeOption('#switchActiveConfig', editConfig);
        removeConfigFile(editConfig);
    }
}

function addOption(selector, nameValue) {
    const nodeList = d.qSA(selector);
    return nodeList.forEach(function(data, index) {
        let optEl = document.createElement('option');
        optEl.innerHTML = nameValue;
        optEl.value = nameValue;
        data.appendChild(optEl);
    });
}

function clearMenus(selector) {
    const nodeList = d.qSA(selector);
    nodeList.forEach(function(el) {
        el.innerHTML = '';
    })
}

function removeOption(selector, match) {
    const nodeList = d.qSA(selector);
    Array.prototype.map.call(nodeList, function(data, index) {
        return Array.prototype.map.call(data, function(item) {
            String(item.innerHTML).match(match) ||
            String(item.value).match(match) ? data.remove(item.index) : null;
        });
    });
}

function loadPairsMenu() {
    let pairsmenu = d.gEBI('pairsmenu');
    for (let i = 0; i < LS.gO(NormalizerService.generateLocalStorageKey('validPairs')).length; i++) {
        let opt = document.createElement('option');
        opt.innerHTML = LS.gO(NormalizerService.generateLocalStorageKey('validPairs'))[i];
        opt.value = LS.gO(NormalizerService.generateLocalStorageKey('validPairs'))[i].toLowerCase();
        pairsmenu.appendChild(opt);
    }
}

function fillBlackList() {
    let fullList = []
    let validpairsarr = LS.gO(NormalizerService.generateLocalStorageKey('validPairs'));
    const settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    const eCfg = settingsObj['editingConfig']
    const allowed = new RegExp(/^(?!#.*$).*_trading_enabled/, 'gi');
    const falseRegex = new RegExp(/.*false.*/, 'i');
    const allRegex = new RegExp(/.*all.*/, 'i');
    let list = document.createElement('ul');
    let item;
    let listTypeClass;
    let whitelist;
    let invalidPairs;
    let filteredBlacklist;
    let blackList = [];
    const raw = settingsObj['files'][eCfg]['PAIRS'];
    const rawKeys = Object.keys(raw);
    const enabledPairsCheck = rawKeys.indexOf('enabled_pairs');
    const typedName = rawKeys[enabledPairsCheck];
    const filtered = rawKeys.filter(key => key.match(allowed)).reduce((obj, key) => {
        if (raw[key].match(falseRegex)) {
            obj[key] = raw[key]
        }
        return obj;
    }, {});
    if (typedName !== undefined && !raw[typedName].match(allRegex)) {
        listTypeClass = 'epMode'
        console.log('enabled_pairs is present')
        whitelist = raw[typedName].toUpperCase().split(',').map(Function.prototype.call, String.prototype.trim);
        filteredBlacklist = validpairsarr.diff(whitelist)
    } else {
        console.log('XXX_trading_enabled is the blacklist format')
        Object.keys(filtered).forEach(function(listItems) {
            blackList.push(listItems.split('_')[0].toUpperCase())
        });
        whitelist = validpairsarr.diff(blackList)
        invalidPairs = blackList.diff(validpairsarr)
        filteredBlacklist = blackList.diff(invalidPairs)
        listTypeClass = 'blMode'
    }
    filteredBlacklist.map(function(pair) {
        fullList.push([pair, "tradingOFF"])
    })
    whitelist.map(function(pair) {
        fullList.push([pair, "tradingON"])
    })
    fullList = fullList.sort()
    list.classList = 'list-group list-group-flush'
    list.style.overflowY = 'scroll';
    list.style.height = '50vh'

    for (let i = 0; i < fullList.length; i++) {
        item = document.createElement('li');
        item.classList = 'list-group-item blackListItem ' + listTypeClass + " " + fullList[i][1]
        item.appendChild(document.createTextNode(fullList[i][0]));
        list.appendChild(item);
    }
    return list;
}

function loadMarketLabels() {
    d.qSA('label[for^=price_]').forEach(function(x) {
        let y = x.innerHTML;
        let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        let configName = settingsObj['configName']
        let ptm = settingsObj['files'][configName]['PAIRS']['price_trigger_market']
        x.innerHTML = ptm + ' ' + y.split(' ').slice(1).join(' ');
    })
}

function changeSetting(filePath, setting, value) {
    checkRole();
    if(supportAccess) {
        Swal.fire(i18next.t('alertMsgs.notAllowed'));
    } else {
        let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        let settingKeys = Object.keys(settingsObj['files'][settingsObj['editingConfig']][filePath]);
        let lowerKeys = settingKeys.toLocaleString().toLowerCase().split(',')
        let settingIndex = lowerKeys.indexOf(setting)
        let newSettingName = '';
        if (settingIndex !== -1) {
            newSettingName = settingKeys[settingIndex];
        } else {
            newSettingName = setting;
        }
        if (value === "remove") {
            delete settingsObj['files'][settingsObj['editingConfig']][filePath][newSettingName]
            LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj)
        } else {
            settingsObj['files'][settingsObj['editingConfig']][filePath][newSettingName] = value;
            LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj)
        }
    }
}

function changeSettingHandler(target) {
    notSaved('show');
    let obj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let filePath = target.dataset.settingType;
    obj = obj['files'][obj['editingConfig']][filePath]
    let settingKeys = Object.keys(obj);
    target.classList.add("newback")
    let setting = target.getAttribute('id');
    let lowerKeys = settingKeys.toLocaleString().toLowerCase().split(',')
    let settingIndex = lowerKeys.indexOf(setting)
    let realName = '';
    if (settingIndex !== -1) {
        realName = settingKeys[settingIndex]
    } else {
        realName = setting;
    }
    let value = '';
    let partsOfStr;
    if (target.getAttribute('type') == 'checkbox') {
        value = String(target.checked);
        changeSetting(filePath, realName, value);
    } else
        value = target.value;
    if (!value.includes(',') || target.getAttribute('type') == 'checkbox') {
        for (key in obj) {
            if (String(key)
                .includes(String(realName))) {
                delete obj[key];
            }
        }
        changeSetting(filePath, realName, value);
    } else if (value.includes(',')) {
        let dcaBuyPercentageMatch =
            new RegExp(/.*dca_buy_percentage/, 'i');
        let dcaBuyTriggerMatch =
            new RegExp(/.*dca_buy_trigger/, 'i');
        let buyOrSellStrategy =
            new RegExp(/.*_strategy/, 'i');
        let dcaSellTriggersMatch =
            new RegExp(/.*dca_[A-Z]_sell_value_.*/, 'i');

        //The setting we are editing can only match one of these regexes not all of them.
        //This is what is causing settings to disappear
        //So let choose what to use first
        //I am filling a dummy Regex as I do not know if a let defined inside an IF can work afterwards
        let regexMatch = new RegExp(/.*DUMMY_I_DONT/, 'i');
        if (realName.match(dcaBuyPercentageMatch)) {
            regexMatch = dcaBuyPercentageMatch;
        } else if (realName.match(dcaBuyTriggerMatch)) {
            regexMatch = dcaBuyTriggerMatch;
        } else if (realName.match(buyOrSellStrategy)) {
            regexMatch = buyOrSellStrategy;
        } else if (realName.match(dcaSellTriggersMatch)) {
            regexMatch = dcaSellTriggersMatch;
        }

        settingKeys.map(function(x) {
            if (x.match(regexMatch)) {
                changeSetting(filePath, x, "remove");
            }
        })
        partsOfStr = value.split(',');
        partsOfStr.forEach(function(x, y) {
            let newdex = y + 1;
            let newsetting = realName + "_" + newdex;
            newval = x;
            changeSetting(filePath, newsetting, newval);
        });
    } else
        changeSetting(filePath, realName, value);
}

function allSets() {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let mainform = d.gEBI('mainform');
    let eCfg = settingsObj['editingConfig'];
    let pairs = settingsObj['files'][eCfg]['PAIRS']
    let dca = settingsObj['files'][eCfg]['DCA']
    let ind = settingsObj['files'][eCfg]['INDICATORS']
    d.gEBI('configDropdown2').value = eCfg;
    [pairs, dca, ind].map(function(x) {
        eachSetting(x)
    })
}

function findCombined() {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let mainform = d.gEBI('mainform');
    let eCfg = settingsObj['editingConfig'];
    let pairs = filterCombine(Object.keys(settingsObj['files'][eCfg]['PAIRS']))
    let dca = filterCombine(Object.keys(settingsObj['files'][eCfg]['DCA']))
    //  console.log(pairs.length, dca.length)
    let totarr = [...pairs, ...dca]
    // console.log(totarr)
    let dcac = document.querySelector('.dcacombined')
    let pairsc = document.querySelector('.pairscombined');
    let notset = [dcac.id, pairsc.id].diff(totarr)
    notset.forEach(function(y) {
        let newel = d.gEBI(y);
        newel.checked = true;
    })

}

function filterCombine(array) {
    let combinedPendingSwitch =
        new RegExp(/.*[^?dca]combine_pending_orders/, 'i');
    let filteredCombined = array.filter(
        function(item) {
            return item.match(combinedPendingSwitch)
        });
    return filteredCombined;
}

function updateGuiConfigFields(fileName) {
    // TODO: Remove this function as well as it is not required.
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    let output = settingsObj['files'][eCfg][fileName];
    eachSetting(output);
}

function eachSetting(obj) {
    let settings = Object.keys(obj);

    let dcaBuyPercentages = [];
    let dcaBuyTriggers = [];
    let dcaSellTriggers = [];
    let dcaBuyPercentageMatch =
        new RegExp(/DCA_buy_percentage/, 'i');
    let dcaBuyTriggerMatch =
        new RegExp(/DCA_buy_trigger/, 'i');
    let buyOrSellStrategy =
        new RegExp(/.*_strategy/, 'i');
    let dcaSellTriggersMatch =
        new RegExp(/.*DCA_[A-Z]_sell_value_.*/, 'i');

    let dcaBuyTrigger =
        d.gEBI('default_dca_buy_trigger');
    let dcaBuyPercentage =
        d.gEBI('default_dca_buy_percentage');
    let dcaSellTrigger = ''
    let dcaSellTriggerList = {};
    settings.forEach(function(x) {
        let descrips = Object.getOwnPropertyDescriptor(obj, x);
        let elId = String(x).toLowerCase();
        let setString = String(descrips.value);
        el = d.gEBI(elId);


        if (!el) {

            if (x.match(buyOrSellStrategy)) {
                x.value = 'Choose...';
                x.disabled = true;
            }
            if (x.match(dcaSellTriggersMatch)) {
                let y = x.split('_')
                let z = y.pop()
                y = y.join('_')
                let test = d.gEBI(y)
                dcaSellTrigger = test
                test ? test.disabled = false : null;
                dcaSellTriggerList[y] = [];
                dcaSellTriggerList[y].push(descrips.value);
                test ? test.value = dcaSellTriggerList[y] : null;
            }
            if (x.match(dcaBuyTriggerMatch)) {
                dcaBuyTriggers.push(descrips.value);
            }
            if (x.match(dcaBuyPercentageMatch)) {
                dcaBuyPercentages.push(descrips.value);
            }
            if (elId.split('_')[0] === 'default' &&
                currentlyEditing !== 'default') {
                let elId2 = String(currentlyEditing + '_' + elId.split('_')
                    .slice(1).join('_'));
                let el2 = d.gEBI(elId2);
                if (!el2) {
                    if (x.match(dcaBuyPercentageMatch)) {
                        dcaBuyPercentages.push(descrips.value);
                    }
                    if (x.match(dcaBuyTriggerMatch)) {
                        dcaBuyTriggers.push(descrips.value);
                    }
                    if (x.match(dcaSellTriggersMatch)) {
                        let y = x.split('_')
                        let z = y.pop()
                        y = y.join('_')
                        let test = d.gEBI(y)
                        dcaSellTrigger = test
                        test ? test.disabled = false : null;
                        dcaSellTriggerList[y] = [];
                        dcaSellTriggerList[y].push(descrips.value);
                        test ? test.value = dcaSellTriggerList[y] : null;
                    }
                } else if (!el2.classList.contains('plusminus')) {
                    if (el2.type == 'checkbox') {
                        if (setString === 'true') {
                            el2.checked = true;
                        } else if (setString === 'false') {
                            el2.checked = false;
                        }
                    }
                    if (el2.disabled) {
                        el2.disabled = false;
                        el2.value = setString;
                    }
                }
            }
            if (LS.gI(NormalizerService.generateLocalStorageKey(elId.slice(0, -2)))) {
                let newel = d.gEBI(elId.slice(0, -2));
                if (newel) {
                    let el2val =
                        String(LS.gI(NormalizerService.generateLocalStorageKey(elId.slice(0, -2))));
                    newel.value = el2val;
                    newel.disabled = false;
                }
            }
        } else {
            if (el.type === 'checkbox') {
                if (setString === 'true') {
                    el.checked = true;
                } else if (setString === 'false') {
                    el.checked = false;
                }
            } else
            if (el.disabled) {
                el.disabled = false;
            }
            el.value = setString;
        }
    });
    if (dcaBuyTriggers.length > 0) {
        if (dcaBuyTrigger) {
            dcaBuyTrigger.value = dcaBuyTriggers.join(',');
        }
    }
    if (dcaBuyPercentages.length > 0) {
        if (dcaBuyPercentage) {
            dcaBuyPercentage.value = dcaBuyPercentages.join(',');
        }
    }
    if (dcaSellTriggers.length > 0) {
        if (dcaSellTrigger) {
            dcaSellTrigger.value = dcaSellTriggers.join(',');
        }
    }
    togglePlusMinus();

}

function loadACE(filename) {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    settingsObj['editingFile'] = filename;
    if (eCfg !== undefined) {
        let newarray = [];
        let myEditor = DomHelper.getGlobalEditor('PBConfigEditor');
        myEditor.focus();
        silent = true;
        if (settingsObj['files'] !== undefined && settingsObj['files'][eCfg][filename]) {
            let data = settingsObj['files'][eCfg][filename];
            let settingName = Object.keys(data);
            forEachThenCallback(data, newarray, function() {
                let newdata = newarray.join('\n');
                myEditor.session.setValue(newdata, -1);
            })
        } else {
            myEditor.session.setValue('', -1);
        }
        silent = false;
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        notSaved('hide');
        handleEditorContentChg(myEditor)
    }
}

function forEachThenCallback(data, newarray, cb) {
    let objkeys = Object.keys(data)
    for (let i = 0; i < objkeys.length; i++) {
        let newkey = objkeys[i];
        if (newkey.match(/comment.*/)) {
            // console.log(data[newkey]+' '+newkey)
            newarray.push(data[newkey])
        } else {
            newarray.push(newkey + ' = ' + data[newkey])
        }
    }
    cb()
}

function saveFormNewName(newName) {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    let pairsObj = settingsObj['files'][eCfg]['PAIRS'];
    let dcaObj = settingsObj['files'][eCfg]['DCA']
    let indicatorsObj = settingsObj['files'][eCfg]['INDICATORS'];
    let updatedText1 = '';
    let updatedText2 = '';
    let updatedText3 = '';
    notSaved('hide');
    for (x in pairsObj) {
        if(x.includes('comment-')) {
            updatedText1 += pairsObj[x] + "\n"
        } else {
            updatedText1 += x + " = " + pairsObj[x] + "\n";
        }
    }
    for (y in dcaObj) {
        if(y.includes('comment-')) {
            updatedText2 += dcaObj[y] + "\n"
        } else {
            updatedText2 += x + " = " + dcaObj[y] + "\n";
        }
    }
    for (z in indicatorsObj) {
        if(z.includes('comment-')) {
            updatedText3 += indicatorsObj[z] + "\n"
        } else {
            updatedText3 += z + " = " + indicatorsObj[z] + "\n";
        }
    }

    Service.saveAll(newName, updatedText1, updatedText2, updatedText3);
    d.qSA('.newback').forEach(function(x) {
        x.classList.remove('newback');
    })

}

function saveForm(filePath, reloader) {
    notSaved('hide');
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    let obj = settingsObj['files'][eCfg][filePath];
    let updatedText = '';
    for (x in obj) {
        //console.log(x)
        updatedText += x + " = " + obj[x] + "\n";
    }
    //console.log(updatedText)
    checkRole();
    Service.saveConfigFile(filePath, updatedText, eCfg, showError, reloader);
    d.qSA('.newback').forEach(function(x) {
        x.classList.remove('newback');
    })
    $('#config-save-loader').css('visibility', $('#config-save-loader').css('visibility') == 'hidden' ? 'visible' : 'hidden');
}

function newConfigNameInputSave(value) {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    value = value.replace(/[^A-Z0-9]+/ig, "_");
    let configName = settingsObj['editingConfig'];
    if (value && value !== '') {
        settingsObj['editingConfig'] = value;
        addOption('#switchActiveConfig', value);
        addOption('.config-dropdown', value);
        d.qSA('.config-dropdown').forEach(
            function(x) {
                if (x.id !== 'switchActiveConfig') {
                    x.value = value;
                }
            }
        )
        settingsObj.files[value] = settingsObj.files[configName];
        settingsObj.availableConfigs.push(value);
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        Service.copyConfig(configName, value)
        //loadConfigForEditing(value);e
        //storeConfigLoadForEdit(value)
    } else {
        alert('Pick a name!');
    }
}

function backup() {
    notSaved('hide');

    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];

    var tmpLink = '<a class="logs-download hide" href="' + PBConstants.BASE_API_URL + '/settings/config/zipped?configName=' + eCfg +'"></a>';
    $('body').append(tmpLink);
    var $logsDownloadLink = $('.logs-download');
    $logsDownloadLink[0].click();
    $logsDownloadLink.remove();
}

function notSaved(showOrhide) {
    if (showOrhide === 'show') {
        d.qSA('.show-save-message').forEach(
            function(el) {
                el.classList.add('not-saved');
                el.style.display = 'inline-block';
            }
        )
    } else {
        d.qSA('.show-save-message').forEach(
            function(el) {
                el.classList.remove('not-saved');
                el.style.display = 'none';
            }
        )
    }
}

function handleEditorContentChg(editor) {
    editor.getSession().on('change', function() {
        if (!silent) {
            let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
            if (settingsObj == null || settingsObj['editingFile'] === 'HOTCONFIG') {
                return;
            }
            d.qSA('.show-save-message').forEach(
                function(el) {
                    el.classList.add('not-saved');
                    el.style.display = 'inline-block';
                }
            )
        }
    });
}

function RateLimit(fn, delay, context) {
    let queue = [],
        timer = null;

    function processQueue() {
        let item = queue.shift();
        if (item)
            fn.apply(item.context, item.arguments);
        if (queue.length === 0)
            clearInterval(timer), timer = null;
    }
    return function limited() {
        queue.push({
            context: context || this,
            arguments: [].slice.call(arguments)
        });
        if (!timer) {
            processQueue(); // start immediately on the first invocation
            timer = setInterval(processQueue, delay);
        }
    }
}
