<#include "/includes/version.ftl">
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <meta name="ProfitTrailer" content="The one and only ProfitTrailer Monitor">
    <meta name="Elroy" content="ProfitTrailer">
    <meta name="dj_crypto" content="ProfitTrailer">
    <meta name="robots" content="noindex, nofollow">
    <link rel="shortcut icon" href="${springMacroRequestContext.contextPath}/images/favicon-32x32.png">
    <title>ProfitTrailer Setup</title>
    <link href="${springMacroRequestContext.contextPath}/css/vendor/responsive.bootstrap4.min.css?ver=${version}" rel="stylesheet" type="text/css" />
    <link href="${springMacroRequestContext.contextPath}/css/vendor/bootstrap.min.css?ver=${version}" rel="stylesheet" type="text/css">
    <link href="${springMacroRequestContext.contextPath}/css/vendor/icons.min.css?ver=${version}" rel="stylesheet" type="text/css">
    <link href="${springMacroRequestContext.contextPath}/css/style.css?ver=${version}" rel="stylesheet" type="text/css">
    <link href="${springMacroRequestContext.contextPath}/css/themes/dark/template-style.css?ver=${version}" rel="stylesheet" type="text/css" id="customTheme">
    <script src="${springMacroRequestContext.contextPath}/js/vendor/jquery.min.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/vendor/popper.min.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/vendor/fastclick.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/vendor/bootstrap.min.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/vendor/detect.min.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/vendor/jquery.slimscroll.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/custom/templateThemes.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/vendor/jquery.app.js?ver=${version}"></script>
    <script src="${springMacroRequestContext.contextPath}/js/vendor/modernizr.min.js?ver=${version}"></script>
    <script>
      $(document).ready(function() {
            if (location.hash) {
              $('a[href=\'' + location.hash + '\']').tab('show');
            }
            var activeTab = localStorage.getItem('setupActiveTab');
            if (activeTab) {
              $('a[href="' + activeTab + '"]').tab('show');
            } else {
              $('a[href="#publicConfig"]').tab('show');
            }

            $('body').on('click', 'a[data-toggle=\'tab\']', function (e) {
              e.preventDefault()
              var tab_name = this.getAttribute('href')
              if (history.pushState) {
                history.pushState(null, null, tab_name)
              }
              else {
                location.hash = tab_name
              }
              localStorage.setItem('setupActiveTab', tab_name)

              $(this).tab('show');
              return false;
            });
            $(window).on('popstate', function () {
              var anchor = location.hash ||
                $('a[data-toggle=\'tab\']').first().attr('href');
              $('a[href=\'' + anchor + '\']').tab('show');
            });
      });
    </script>
  </head>
  <body>
    <div class="ex-page-content">
      <div class="container">
        <div class="row justify-content-lg-center">
          <div class="col-lg-8">
            <div class="message-box setup-page-container">
              <div class="buttons-con">
                <div class="text-center">
                  <a class="logo"><img src="${springMacroRequestContext.contextPath}/images/Logo.png" alt="ProfitTrailer" height="35" width="35"><span class="tdbitcoin">Profit</span><span class="text-primary">Trailer</span></a>
                </div>
                <p>
                <ul class="nav nav-pills nav-justified form-wizard-header mb-3">
                  <li class="nav-item">
                    <a class="nav-link">
                      <span class="number">1.</span>
                      <span class="d-none d-sm-inline">License</span>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link">
                      <span class="number">2.</span>
                      <span class="d-none d-sm-inline">Exchange</span>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a class="nav-link active">
                      <span class="number">3.</span>
                      <span class="d-none d-sm-inline">Config</span>
                    </a>
                  </li>
                </ul>
                <div id="bar" class="progress mb-3 row" style="height: 7px;">
                  <div class="bar progress-bar progress-bar-striped progress-bar-animated" style="width: 95%;background-color: #FF9900"></div>
                </div>
                <div class="card-box">
                  <ul class="nav nav-tabs tabs-bordered">
                    <li class="nav-item">
                      <a href="#publicConfig" data-toggle="tab" aria-expanded="false" class="nav-link active">
                      Public
                      </a>
                    </li>
                    <li class="nav-item">
                      <a href="#savedConfig" data-toggle="tab" aria-expanded="false" class="nav-link">
                      Saved
                      </a>
                    </li>
                  </ul>
                  <div class="tab-content">
                    <div class="tab-pane fade show active" id="publicConfig">
                      <div class="tab-description">
                        Choose from our database of public configs and copy it to your bot giving it a unique name.
                      </div>
                      <form action="" method="POST" class="m-t-20" name="publicConfig">
                        <input type="hidden" name="tab" value="publicConfig" />
                        <div class="form-group">
                          <select name="publicConfig" class="form-control">
                            <#list selectConfig as value>
                            <option value="${value}">${value}</option>
                            </#list>
                            <#if publicConfigs?? && publicConfigs?size gt 0>
                            <optgroup label="Default Configs">
                              <#list publicConfigs as value>
                              <option value="${value}">${value}</option>
                              </#list>
                            </optgroup>
                            </#if>
                            <#if signalConfigs?? && signalConfigs?size gt 0>
                            <optgroup label="Signal Configs">
                              <#list signalConfigs as value>
                              <option value="${value}">${value}</option>
                              </#list>
                            </optgroup>
                            </#if>
                          </select>
                        </div>
                        <div class="form-group">
                          <input name="publicConfigName" type="text" class="form-control" placeholder="Choose a new name" autocomplete="off">
                        </div>
                        <i class="md md-vpn-key form-control-feedback l-h-34" style="left:6px;z-index: 99;"></i>
                        <div class="input-group-btn">
                          <button type="submit" class="btn btn-email btn-primary waves-effect waves-light text-dark float-right">Load your settings</button>
                        </div>
                        <span class="text-danger">${error!""}</span>
                      </form>
                    </div>
                    <div class="tab-pane fade" id="savedConfig">
                      <div class="tab-description">
                        Choose from one of your own configs that you have already created in the past.
                      </div>
                      <form action="" method="POST" class="m-t-20" name="savedConfig">
                        <input type="hidden" name="tab" value="savedConfig" />
                        <div class="form-group">
                          <#if availableConfigs??>
                          <select name="existingConfig" class="form-control">
                            <#list availableConfigs as configName>
                            <#assign isSelected = selectedConfig == configName>
                            <option value="${configName}" <#if isSelected> selected="selected"</#if>>${configName}</option>
                            </#list>
                          </select>
                          </#if>
                        </div>
                        <i class="md md-vpn-key form-control-feedback l-h-34" style="left:6px;z-index: 99;"></i>
                        <div class="input-group-btn">
                          <button type="submit" class="btn btn-email btn-primary waves-effect waves-light text-dark float-right">Load your settings</button>
                        </div>
                        <span class="text-danger">${error!""}</span>
                      </form>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </body>
</html>